options nosource nonotes;

%macro ct_cal(in_file,y_rang,d_out);
proc import out=aa datafile=".\out_map\&in_file" dbms=dbf replace;
run;

data aa1;
  length rate_c $35;
  set aa;
  if rate1=. then delete;
  else if rate1 le 5 then rate_c=" 0 - 5";
  else if rate1 le 10 then rate_c=" 5 - 10";
  else if rate1 le 20 then rate_c="10 - 20";
  else if rate1 le 40 then rate_c="20 - 40";
  else if rate1 le 80 then rate_c="40 - 70";
run;

proc means data=aa1 noprint;
  var d_1 tot;
  output out=s_tot sum=;
run;

data s_tot1(keep=rate_c &y_rang);
  length rate_c $35;
   set s_tot;
   rate_c="Total Number of children > 5 ug/dl";
   &y_rang=d_1;
   output;
   rate_c="zPercent of children > 5 ug/dl";
   &y_rang=d_1*100/tot;
   output;
 run;

proc freq data=aa1;
  table rate_c/noprint out=vv;
run;

data vv1(keep=rate_c &y_rang);
  set vv ;
  &y_rang=count;
run;

data &d_out;
  set vv1 s_tot1;
run;


proc sort data=&d_out;
  by rate_c;
run;

%mend ct_cal;

%ct_cal(mi06_07.dbf,mi06_07,b1);

%ct_cal(mi08_10.dbf,mi08_10,b2);
%ct_cal(mi11_13.dbf,mi11_13,b3);
%ct_cal(mi14_16.dbf,mi14_16,b4);

data tot;
 merge b1 b2 b3 b4;
 by rate_c;
run;


proc export data=tot outfile="./tab/o_tab_1.xlsx" dbms=xlsx replace;
  sheet=change;
run;
