options nosource nomprint nonotes;
%MACRO CONV_TWO(in1,in2,cmt);
**** test rate  95th and 99th percentile significant only ;
proc datasets lib=work nolist;
  delete a: b: o: t: v:;
run;

*** 2014 to 2016 0-7 years Getis ORD GI hot spot;
proc import out=BLL_00 datafile=".\out_map\&IN1..dbf" dbms=dbf replace;
run;

data bll_01(keep =geoid gi_bin  hotspot);
  length geoid 8;
  set bll_00;
  geoid=mi_tract_3*1;
  if gi_bin in (2,3) then hotspot=1;
  else hotspot=0;
run;

*** 2006 to 2013 0-7 years Getis ORD GI hot spot;

proc import out=B07_00 datafile=".\out_map\&IN2..dbf" dbms=dbf replace;
run;

data b07_01(keep =geoid gi_bin );
  length geoid 8;
  set B07_00;
  geoid=mi_tract_3*1;
run;


data b07_02;
  set b07_01 (rename=( gi_bin=o_gi_bin ));
    if o_gi_bin in (2,3) then o_hotspot=1;
    else o_hotspot=0;
run;

proc sort data=bll_01;
  by geoid;
run;

proc sort data=b07_02;
  by geoid;
run;


data tot_all;
 merge bll_01(in=a) b07_02(in=b);
 by geoid;
 if (a and b);
run;

%MACRO M_FREQ(in_1,in_2,text );


* calculate freq and put data together;


%macro pre_b(comp);
proc freq data=tot_all;
   table  &in_1*&in_2/noprint out=vv;
run;

data vv(keep=comp c_1 c_2 count);
  length comp $100;
  set vv;
  if percent=. then delete;
  comp="&comp";
  c_1=&in_1;
  c_2=&in_2;
run;

proc append data=vv out=tot_frq;
run;

%mend pre_b;

proc datasets lib=work nolist;
  delete tot_frq;
run;


%pre_b(&text);

*** calculate sensitivity, specifity, false positive and negative rate and statistics test;

proc sort data=tot_frq out=a_1;
 by comp;
run;
*ods output on;
*ods trace on;
proc freq data=a_1;
   ods output chisq=o_1 kappatest=o_2;
   tables c_1*c_2 / chisq agree;
     test kappa;
   weight Count;
   by comp;
run;

data a_2;
  set a_1;
  if c_1=1 and c_2=1 then name0="TP";
  if c_1=1 and c_2=0 then name0="FN";
  if c_1=0 and c_2=1 then name0="FP";
  if c_1=0 and c_2=0 then name0="TN";
run;

proc transpose data=a_2 out=a_r;
  var count;
  id name0;
  by comp;
run;

data a_r1;
  set a_r;
  tot=sum(of TP FN FP TN);
  
  sensitivity=TP*100/(TP+FN);
  specificity=TN*100/(FP +TN);
  p_o=(TP+TN)/tot;
  p_yes=(TP+FN) *(TP+FP)/(tot*tot);
  p_no=(FP+TN) *(FN+TN)/(tot*tot);
  p_e=p_yes+p_no;
  c_kappa=(p_o-p_e)/(1-p_e);

  FPR=100*FP/(FP+TN);
  FNR=100*FN/(FN+TP);

run;

data tst_01(keep=comp p_MH_chi);
  set o_1;
   p_MH_chi=prob;
  if statistic="Mantel-Haenszel Chi-Square" then output;
run;

data tst_02(keep=comp p_kappa );
  set o_2;
   p_kappa=cValue1;
  if name1="PR_KAPPA" then output;
run;

data o_f(drop=p_:);
  merge a_r1(drop=_:) tst_01 tst_02;
  by comp;
run;

data o_f1(keep=comp o_:);
  set o_f;
  array ooo{10} o_tn o_fn o_fp o_tp o_tot o_sensitivity o_specificity o_fnr o_fpr o_c_kappa;
  array xxx{10} tn fn fp tp tot sensitivity specificity fnr fpr c_kappa;
  do i=1 to 10;
  ooo{i}=xxx{i};
  end;
run;

data o_f2(drop= o_: i);
  set o_f1;
  array ooo{10} o_tn o_fn o_fp o_tp o_tot o_sensitivity o_specificity o_fnr o_fpr o_c_kappa;
  array xxx{10} tn fn fp tp tot sensitivity specificity fnr fpr c_kappa;
  do i=1 to 10;
  xxx{i}=ooo{i};
  end;
run;


proc append data=o_f2 out=&out_d;
run;


%MEND M_FREQ;




%M_FREQ(hotspot,o_hotspot,&cmt);

%MEND CONV_TWO;

****************************************************************************************;

*** change geoid id so that they are consistent;

proc import out=t1 datafile=".\out_map\o_getis_sch.dbf" dbms=dbf replace;
run;

data t1(rename=(tract=mi_tract_3 geoid=fips));
  set t1;
run;

proc export data=t1 outfile=".\out_map\oo_getis_sch.dbf" dbms=dbf replace;
run;
****************************************************************************************;

%let out_d=z_tot;

proc datasets lib=work nolist;
  delete &out_d;
run;




%conv_two(o_G_06_13,o_ct14_16,Exceedance Rate of EBLLs: 2006-2013 vs. 2014-2016);
%conv_two(o_ct14_16,o_gTen_14_16,Exceedance Rate of EBLLs:=5 vs. =10 g/dL 2014-2016);
%conv_two(o_ct14_16,o_getis_ej,Exceedance Rate of EBLLs 2014-2016 vs. EJSCREEN);
%conv_two(o_ct14_16,oo_getis_sch,Exceedance Rate of EBLLs 2014-2016 vs. Schultz);
%conv_two(o_ct14_16,o_getis_hud,Exceedance Rate of EBLLs 2014-2016 vs. HUD);

%conv_two(o_getis_ej,oo_getis_sch,EJSCREEN vs. Schultz);
%conv_two(o_getis_ej,o_getis_hud,EJSCREEN vs. HUD);
%conv_two(oo_getis_sch,o_getis_hud,Schultz vs. HUD);

data z_tot1(keep=comp tot sen: spe: c_k:);
  set z_tot;
run;

proc export data=z_tot1 outfile="./tab/o_tab_2.xlsx" dbms=xlsx replace;
  sheet=conv;
run;


proc export data=z_tot outfile="./tab/o_tab_2.xlsx" dbms=xlsx replace;
  sheet=conv_all;
run;

